searchData={"items":[{"type":"module","title":"gen_icmp","doc":"gen_icmp is an interface for using ICMP and ICMPv6 sockets gen_icmp uses raw sockets and abuses gen_udp for the socket handling. gen_icmp should work on Linux and BSDs. Examples 1 &gt; gen_icmp : ping ( &quot;hex.pm&quot; ) . [ { ok , &quot;hex.pm&quot; , { 35 , 241 , 14 , 39 } , { 35 , 241 , 14 , 39 } , { 61261 , 0 , 116 , 215 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ]","ref":"gen_icmp.html"},{"type":"function","title":"gen_icmp.addr_list/3","doc":"Resolve a host list. Examples 1 &gt; gen_icmp : addr_list ( inet , [ &quot;8.8.8.8&quot; , &quot;google.com&quot; , &quot;cloudflare.com&quot; , { 8 , 8 , 8 , 8 } , &quot;8.8.8.8&quot; ] , false ) . [ { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } , { ok , &quot;google.com&quot; , { 172 , 217 , 165 , 14 } } , { ok , &quot;cloudflare.com&quot; , { 104 , 16 , 133 , 229 } } , { ok , { 8 , 8 , 8 , 8 } , { 8 , 8 , 8 , 8 } } , { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } ] 2 &gt; [ { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } , { ok , &quot;google.com&quot; , { 172 , 217 , 165 , 14 } } , { ok , &quot;cloudflare.com&quot; , { 104 , 16 , 132 , 229 } } , { ok , &quot;cloudflare.com&quot; , { 104 , 16 , 133 , 229 } } , { ok , { 8 , 8 , 8 , 8 } , { 8 , 8 , 8 , 8 } } , { ok , &quot;8.8.8.8&quot; , { 8 , 8 , 8 , 8 } } ]","ref":"gen_icmp.html#addr_list/3"},{"type":"function","title":"gen_icmp.close/1","doc":"Close the ICMP socket. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#close/1"},{"type":"function","title":"gen_icmp.controlling_process/2","doc":"Change the controlling process of the ICMP socket. Change the process owning the socket. Allows another process to receive the ICMP responses.","ref":"gen_icmp.html#controlling_process/2"},{"type":"function","title":"gen_icmp.echo/3","doc":"Generate ICMP ECHO_REQUEST payload. Creates an ICMP echo packet with an 8 byte timestamp and a payload consisting of ASCII 32 to 79. Examples 1 &gt; gen_icmp : echo ( inet , 0 , 0 ) . &lt;&lt; 8 , 0 , 166 , 49 , 0 , 0 , 0 , 0 , 255 , 253 , 243 , 182 , 71 , 2 , 233 , 209 , 32 , 33 , 34 , 35 , 36 , 37 , 38 , 39 , 40 , 41 , 42 , 43 , 44 , . . . &gt;&gt;","ref":"gen_icmp.html#echo/3"},{"type":"function","title":"gen_icmp.echo/4","doc":"Generate ICMP ECHO_REQUEST with user specified payload. Creates an ICMP echo packet with the results of erlang:monotonic_time(micro_seconds) used as the timestamp and a user specified payload (padded to 64 bytes). Examples 1 &gt; gen_icmp : echo ( inet , 0 , 0 , &lt;&lt; &quot;ping&quot; , 0 : ( 60 * 8 ) &gt;&gt; ) . &lt;&lt; 8 , 0 , 25 , 47 , 0 , 0 , 0 , 0 , 112 , 105 , 110 , 103 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt;","ref":"gen_icmp.html#echo/4"},{"type":"function","title":"gen_icmp.family/1","doc":"Get socket family. Returns the socket family: inet (IPv4), inet6 (IPv6) Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : family ( S ) . inet6","ref":"gen_icmp.html#family/1"},{"type":"function","title":"gen_icmp.filter/1","doc":"Get ICMPv6 socket filter. Retrieves the ICMPv6 filter for a socket. For ICMPv4 sockets, the atom unsupported is returned. Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : filter ( S ) . { ok , &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; }","ref":"gen_icmp.html#filter/1"},{"type":"function","title":"gen_icmp.filter/2","doc":"Set ICMPv6 socket filter. Sets an ICMPv6 filter on a socket. For ICMPv4 sockets, the atom unsupported is returned. Filters can be generated by using the icmp6_filter functions. Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : filter ( S , gen_icmp : icmp6_filter_setpassall ( ) ) . ok","ref":"gen_icmp.html#filter/2"},{"type":"function","title":"gen_icmp.get_ttl/2","doc":"Get the TTL for a file descriptor. Examples 1 &gt; gen_icmp : get_ttl ( gen_icmp : getfd ( S ) , gen_icmp : family ( S ) ) . { ok , 64 }","ref":"gen_icmp.html#get_ttl/2"},{"type":"function","title":"gen_icmp.getfd/1","doc":"Get underlying file descriptor for socket. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.221 . 0 &gt; } 2 &gt; gen_icmp : getfd ( S ) . 20","ref":"gen_icmp.html#getfd/1"},{"type":"function","title":"gen_icmp.icmp6_filter_setblock/2","doc":"Update a filter to block an ICMPv6 type. Examples To generate a filter that allowed only ICMP6_PACKET_TOO_BIG messages: 1 &gt; { ok , Socket } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.300 . 0 &gt; } 2 &gt; Filter = gen_icmp : icmp6_filter_setblock ( packet_too_big , gen_icmp : icmp6_filter_setpassall ( ) ) . &lt;&lt; 4 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; 3 &gt; gen_icmp : filter ( Socket , Filter ) . ok See also: filter/2 .","ref":"gen_icmp.html#icmp6_filter_setblock/2"},{"type":"function","title":"gen_icmp.icmp6_filter_setblockall/0","doc":"ICMPv6 filtering: block all ICMP types. See also: icmp6_filter_setpass/2 .","ref":"gen_icmp.html#icmp6_filter_setblockall/0"},{"type":"function","title":"gen_icmp.icmp6_filter_setpass/2","doc":"Update a filter to allow an ICMPv6 type. Examples To generate a filter that allowed only ICMP6_ECHO_REPLY messages: { ok , Socket } = gen_icmp : open ( [ inet6 ] ) , Filter = gen_icmp : icmp6_filter_setpass ( echo_reply , gen_icmp : icmp6_filter_setblockall ( ) ) , ok = gen_icmp : filter ( Socket , Filter ) . See also: filter/2 .","ref":"gen_icmp.html#icmp6_filter_setpass/2"},{"type":"function","title":"gen_icmp.icmp6_filter_setpassall/0","doc":"IPv6 ICMP filtering: allow all ICMP types. See also: icmp6_filter_setblock/2 .","ref":"gen_icmp.html#icmp6_filter_setpassall/0"},{"type":"function","title":"gen_icmp.icmp6_filter_willblock/2","doc":"Test if a filter blocks an ICMPv6 type. Examples 1 &gt; Filter = gen_icmp : icmp6_filter_setblock ( packet_too_big , gen_icmp : icmp6_filter_setpassall ( ) ) . &lt;&lt; 4 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; 2 &gt; gen_icmp : icmp6_filter_willblock ( echo_reply , Filter ) . false 3 &gt; gen_icmp : icmp6_filter_willblock ( packet_too_big , Filter ) . true","ref":"gen_icmp.html#icmp6_filter_willblock/2"},{"type":"function","title":"gen_icmp.icmp6_filter_willpass/2","doc":"Test if a filter allows an ICMPv6 type. Examples 1 &gt; Filter = gen_icmp : icmp6_filter_setblock ( packet_too_big , gen_icmp : icmp6_filter_setpassall ( ) ) . &lt;&lt; 4 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , . . . &gt;&gt; 2 &gt; gen_icmp : icmp6_filter_willpass ( echo_reply , Filter ) . true 3 &gt; gen_icmp : icmp6_filter_willpass ( packet_too_big , Filter ) . false","ref":"gen_icmp.html#icmp6_filter_willpass/2"},{"type":"function","title":"gen_icmp.open/0","doc":"Open an ICMP socket. By default, the ICMP socket is opened in {active,false} mode. No packets will be received by the socket. setopts/2 can be used to place the socket in {active,true} mode. gen_icmp first attempts to natively open the socket and falls back to forking the setuid helper program if beam does not have the appropriate privileges. Privileges to open a raw socket can be given by, for example, running as root or, on Linux, granting the CAP_NET_RAW capability to beam: setcap cap_net_raw=ep /usr/local/lib/erlang/erts-5.8.3/bin/beam.smp Only the owning process will receive ICMP packets (see controlling_process/2 to change the owner). The process owning the raw socket will receive all ICMP packets sent to the host. Messages sent to the controlling process are: {icmp, Socket, Address, TTL, Packet} Where: * Socket is the pid of the gen_icmp process * Address is a tuple representing the IPv4 or IPv6 source address * TTL: IPv4: TTL taken from the IP header * TTL: IPv6: the socket's hop limit returned from getsockopt(IPV6_UNICAST_HOPS) (this is not the packet's TTL, it is the socket's max TTL) * Packet is the complete ICMP packet including the ICMP headers Examples 1 &gt; gen_icmp : open ( ) . { ok , &lt; 0.299 . 0 &gt; }","ref":"gen_icmp.html#open/0"},{"type":"function","title":"gen_icmp.open/1","doc":"Open an ICMP socket with raw socket options. See the https://github.com/msantos/procket for the raw socket options and for instructions on setting up the setuid helper. Examples 1 &gt; gen_icmp : open ( [ { ttl , 1 } , inet6 ] ) . { ok , &lt; 0.302 . 0 &gt; }","ref":"gen_icmp.html#open/1"},{"type":"function","title":"gen_icmp.open/2","doc":"Open an ICMP socket with options. Examples 1 &gt; gen_icmp : open ( [ { ttl , 1 } , inet6 ] , [ list ] ) . { ok , &lt; 0.302 . 0 &gt; }","ref":"gen_icmp.html#open/2"},{"type":"function","title":"gen_icmp.packet/2","doc":"Create an ICMP packet. Convenience function for creating arbitrary ICMP packets. This function will calculate the ICMP checksum and insert it into the packet. Examples 1 &gt; rr ( &quot;_build/default/lib/pkt/include/pkt_icmp.hrl&quot; ) . [ icmp ] 2 &gt; gen_icmp : packet ( # icmp { } , &lt;&lt; &quot;abc&quot; &gt;&gt; ) . &lt;&lt; 8 , 0 , 51 , 157 , 0 , 0 , 0 , 0 , 97 , 98 , 99 &gt;&gt;","ref":"gen_icmp.html#packet/2"},{"type":"function","title":"gen_icmp.packet/3","doc":"Construct an ICMP or ICMPv6 packet payload. Examples 1 &gt; gen_icmp : packet ( inet , [ { type , dest_unreach } , { code , unreach_port } ] , &lt;&lt; &quot;payload goes here&quot; &gt;&gt; ) . &lt;&lt; 3 , 3 , 135 , 239 , 0 , 0 , 0 , 0 , 112 , 97 , 121 , 108 , 111 , 97 , 100 , 32 , 103 , 111 , 101 , 115 , 32 , 104 , 101 , 114 , 101 &gt;&gt;","ref":"gen_icmp.html#packet/3"},{"type":"function","title":"gen_icmp.parse/1","doc":"Parse or resolve an IPv4 host identifier. Examples 1 &gt; gen_icmp : parse ( &quot;8.8.8.8&quot; ) . { ok , [ { 8 , 8 , 8 , 8 } ] } 2 &gt; gen_icmp : parse ( { 8 , 8 , 8 , 8 } ) . { ok , [ { 8 , 8 , 8 , 8 } ] } 3 &gt; gen_icmp : parse ( &quot;2001:4860:4860::8888&quot; ) . { ok , [ { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } ] } 4 &gt; gen_icmp : parse ( &quot;cloudflare.com&quot; ) . { ok , [ { 104 , 16 , 132 , 229 } , { 104 , 16 , 133 , 229 } ] } 5 &gt; gen_icmp : parse ( &quot;foo&quot; ) . { error , nxdomain }","ref":"gen_icmp.html#parse/1"},{"type":"function","title":"gen_icmp.parse/2","doc":"Parse or resolve a host identifier. Examples 1 &gt; gen_icmp : parse ( inet , &quot;cloudflare.com&quot; ) . { ok , [ { 104 , 16 , 133 , 229 } , { 104 , 16 , 132 , 229 } ] } 2 &gt; gen_icmp : parse ( inet6 , &quot;cloudflare.com&quot; ) . { ok , [ { 9734 , 18176 , 0 , 0 , 0 , 0 , 26640 , 34021 } , { 9734 , 18176 , 0 , 0 , 0 , 0 , 26640 , 34277 } ] }","ref":"gen_icmp.html#parse/2"},{"type":"function","title":"gen_icmp.ping/1","doc":"Send an ICMP ECHO_REQUEST. ping/1 is a convenience function to send a single ping packet. The argument to ping/1 can be either a hostname or a list of hostnames. Examples 1 &gt; gen_icmp : ping ( &quot;google.com&quot; ) . [ { ok , &quot;google.com&quot; , { 142 , 251 , 41 , 46 } , { 142 , 251 , 41 , 46 } , { 61261 , 0 , 116 , 84 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] See also: ping/3 .","ref":"gen_icmp.html#ping/1"},{"type":"function","title":"gen_icmp.ping/2","doc":"Send an ICMP ECHO_REQUEST with options. Ping a host or a list of hosts. Examples 1 &gt; gen_icmp : ping ( &quot;google.com&quot; , [ inet6 ] ) . [ { ok , &quot;google.com&quot; , { 9735 , 63664 , 16395 , 2052 , 0 , 0 , 0 , 8206 } , { 9735 , 63664 , 16395 , 2052 , 0 , 0 , 0 , 8206 } , { 61261 , 0 , 64 , 53 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] See also: ping/3 .","ref":"gen_icmp.html#ping/2"},{"type":"function","title":"gen_icmp.ping/3","doc":"Send an ICMP ECHO_REQUEST. To prevent the process mailbox from being flooded with ICMP messages, ping/3 will put the socket into {active,false} mode after completing. The ping/3 function blocks until either an ICMP ECHO REPLY is received from all hosts or Timeout is reached. Id and sequence are used to differentiate ping responses. Usually, the sequence is incremented for each ping in one run. A list of responses is returned. If the ping was successful, the elapsed time in milliseconds is included (calculated by subtracting the current time from the time we sent in the ICMP ECHO packet and returned to us in the ICMP ECHOREPLY payload) where: * Host: the provided hostname * Address: the resolved IPv4 or IPv6 network address represented as a 4 or 8-tuple used in the ICMP echo request * ReplyAddr: the IPv4 or IPv6 network address originating the ICMP echo reply The timeout is set for all ICMP packets and is set after all packets have been sent out. By default only one address per hostname is pinged. To enable pinging all addresses per hostname pass {multi, true} to options. A ping payload contains an 8 byte timestamp in microseconds. When creating a custom payload, the first 8 bytes of the ICMP echo reply payload will be used for calculating the elapsed time. To disable this behaviour, use the option {timestamp,false} (the elapsed time in the return value will be set to 0). The timeout defaults to 5 seconds. ICMPv6 sockets can restrict which ICMPv6 types are received by the socket using the filter option. The filter argument is a binary generated using the icmp6_filter functions described below. The default filter allows: ICMP6_ECHO_REPLY, ICMP6_DST_UNREACH, ICMP6_PACKET_TOO_BIG, ICMP6_TIME_EXCEEDED and ICMP6_PARAM_PROB. Note: ping/3 does not restore the original filter on the socket. Examples 1 &gt; { ok , S } = gen_icmp : open ( [ inet6 ] ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : ping ( S , [ &quot;google.com&quot; ] , [ ] ) . [ { ok , &quot;google.com&quot; , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 61261 , 0 , 64 , 110 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 3 &gt; gen_icmp : ping ( S , [ &quot;2001:4860:4860::8888&quot; ] , [ ] ) . [ { ok , &quot;2001:4860:4860::8888&quot; , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 61261 , 0 , 64 , 20 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 4 &gt; gen_icmp : ping ( S , [ &quot;2001:4860:4860::8888&quot; , &quot;google.com&quot; ] , [ ] ) . [ { ok , &quot;google.com&quot; , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 9735 , 63664 , 16395 , 2051 , 0 , 0 , 0 , 8206 } , { 61261 , 1 , 64 , 23 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } , { ok , &quot;2001:4860:4860::8888&quot; , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 8193 , 18528 , 18528 , 0 , 0 , 0 , 0 , 34952 } , { 61261 , 0 , 64 , 23 } , &lt;&lt; &quot; !\\&quot;#$%&amp;&#39;()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNO&quot; &gt;&gt; } ] 5 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#ping/3"},{"type":"function","title":"gen_icmp.recv/2","doc":"Read data from an ICMP socket. This function receives a packet from a socket in passive mode. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : send ( S , &quot;google.com&quot; , gen_icmp : echo ( inet , 0 , 0 ) ) . ok 3 &gt; gen_icmp : recv ( S , 1 ) . { ok , { { 142 , 251 , 32 , 78 } , &lt;&lt; 69 , 0 , 0 , 84 , 0 , 0 , 0 , 0 , 116 , 1 , 214 , 38 , 142 , 251 , 32 , 78 , 100 , 115 , 92 , 198 , 0 , 0 , 19 , 125 , 0 , . . . &gt;&gt; } } 4 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#recv/2"},{"type":"function","title":"gen_icmp.recv/3","doc":"Read data from an ICMP socket with timeout. The optional Timeout parameter specifies a timeout in milliseconds. The default value is infinity. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.299 . 0 &gt; } 2 &gt; gen_icmp : send ( S , &quot;google.com&quot; , gen_icmp : echo ( inet , 0 , 0 ) ) . ok 3 &gt; gen_icmp : recv ( S , 1 , 5000 ) . { ok , { { 142 , 251 , 41 , 78 } , &lt;&lt; 69 , 0 , 0 , 84 , 0 , 0 , 0 , 0 , 116 , 1 , 205 , 38 , 142 , 251 , 41 , 78 , 100 , 115 , 92 , 198 , 0 , 0 , 100 , 77 , 0 , . . . &gt;&gt; } } 4 &gt; gen_icmp : recv ( S , 1 , 5000 ) . { error , timeout } 5 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#recv/3"},{"type":"function","title":"gen_icmp.send/3","doc":"Send data via an ICMP socket. Like the gen_udp and gen_tcp modules, any process can send ICMP packets but only the owner will receive the responses. Examples 1 &gt; { ok , S } = gen_icmp : open ( ) . { ok , &lt; 0.224 . 0 &gt; } 2 &gt; gen_icmp : send ( S , &quot;google.com&quot; , gen_icmp : echo ( inet , 0 , 0 ) ) . ok 3 &gt; gen_icmp : recv ( S , 1 ) . { ok , { { 142 , 251 , 32 , 78 } , &lt;&lt; 69 , 0 , 0 , 84 , 0 , 0 , 0 , 0 , 116 , 1 , 214 , 38 , 142 , 251 , 32 , 78 , 100 , 115 , 92 , 198 , 0 , 0 , 19 , 125 , 0 , . . . &gt;&gt; } } 4 &gt; gen_icmp : close ( S ) . ok","ref":"gen_icmp.html#send/3"},{"type":"function","title":"gen_icmp.set_ttl/3","doc":"Set the TTL on a file descriptor. Examples 1 &gt; gen_icmp : set_ttl ( gen_icmp : getfd ( S ) , gen_icmp : family ( S ) , 1 ) . ok 2 &gt; gen_icmp : get_ttl ( gen_icmp : getfd ( S ) , gen_icmp : family ( S ) ) . { ok , 1 }","ref":"gen_icmp.html#set_ttl/3"},{"type":"function","title":"gen_icmp.setopts/2","doc":"Set socket options. For options, see the inet man page. Simply calls inet:setopts/2 on the gen_udp socket. setopts/2 can be used to toggle the socket between passive and active mode. Examples { ok , Socket } = gen_icmp : open ( ) , % socket is {active,false} ok = gen_icmp : setopts ( Socket , [ { active , true } ] ) , % do stuff with the socket ok = gen_icmp : setopts ( Socket , [ { active , false } ] ) .","ref":"gen_icmp.html#setopts/2"},{"type":"type","title":"gen_icmp.elapsed/0","doc":null,"ref":"gen_icmp.html#t:elapsed/0"},{"type":"type","title":"gen_icmp.fd/0","doc":null,"ref":"gen_icmp.html#t:fd/0"},{"type":"type","title":"gen_icmp.icmp6_filter/0","doc":null,"ref":"gen_icmp.html#t:icmp6_filter/0"},{"type":"type","title":"gen_icmp.id/0","doc":null,"ref":"gen_icmp.html#t:id/0"},{"type":"type","title":"gen_icmp.int32_t/0","doc":null,"ref":"gen_icmp.html#t:int32_t/0"},{"type":"type","title":"gen_icmp.packet_option/0","doc":null,"ref":"gen_icmp.html#t:packet_option/0"},{"type":"type","title":"gen_icmp.sequence/0","doc":null,"ref":"gen_icmp.html#t:sequence/0"},{"type":"type","title":"gen_icmp.socket/0","doc":null,"ref":"gen_icmp.html#t:socket/0"},{"type":"type","title":"gen_icmp.ttlx/0","doc":"ICMP packet time to live (renamed to avoid conflict with ttl() defined in the pkt header file)","ref":"gen_icmp.html#t:ttlx/0"},{"type":"type","title":"gen_icmp.uint8_t/0","doc":null,"ref":"gen_icmp.html#t:uint8_t/0"},{"type":"type","title":"gen_icmp.uint16_t/0","doc":null,"ref":"gen_icmp.html#t:uint16_t/0"},{"type":"type","title":"gen_icmp.uint32_t/0","doc":null,"ref":"gen_icmp.html#t:uint32_t/0"},{"type":"module","title":"tracert","doc":"Perform a traceroute. Send a probe packet with the time to live set from 1. Monitor an ICMP socket for ICMP responses or timeout. Examples 1 &gt; tracert : host ( &quot;hex.pm&quot; ) .","ref":"tracert.html"},{"type":"function","title":"tracert.close/1","doc":"Close the ICMP socket. Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; } 2 &gt; tracert : close ( Socket ) . ok","ref":"tracert.html#close/1"},{"type":"function","title":"tracert.host/1","doc":"Perform an ICMP traceroute to a destination. Examples 1 &gt; tracert : host ( &quot;google.com&quot; ) . [ timeout , { { 142 , 250 , 57 , 128 } , 1174 , { icmp , &lt;&lt; 11 , 0 , 111 , 150 , 0 , 0 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 116 , 64 , 0 , 1 , 1 , 125 , 44 , 10 , 128 , . . . &gt;&gt; } } , { { 172 , 253 , 79 , 98 } , 3418 , { icmp , &lt;&lt; 11 , 0 , 244 , 238 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 117 , 64 , 0 , 1 , 1 , 125 , 43 , 10 , . . . &gt;&gt; } } , { { 192 , 178 , 45 , 217 } , 4103 , { icmp , &lt;&lt; 11 , 0 , 111 , 113 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 118 , 64 , 0 , 1 , 1 , 125 , 42 , . . . &gt;&gt; } } , { { 216 , 239 , 57 , 177 } , 2233 , { icmp , &lt;&lt; 11 , 0 , 111 , 113 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 84 , 128 , 119 , 64 , 0 , 1 , 1 , 125 , . . . &gt;&gt; } } , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 173 , 194 , 195 , 100 } , 975 , { icmp , &lt;&lt; 0 , 0 , 184 , 52 , 205 , 52 , 0 , 0 , 32 , . . . &gt;&gt; } } ]","ref":"tracert.html#host/1"},{"type":"function","title":"tracert.host/2","doc":"Perform a traceroute to a destination with options. Examples 1 &gt; tracert : host ( &quot;google.com&quot; , [ { protocol , udp } ] ) . [ timeout , { { 142 , 250 , 57 , 212 } , 3671 , { icmp , &lt;&lt; 11 , 0 , 0 , 16 , 0 , 0 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 92 , 64 , 0 , 1 , 17 , 109 , 31 , 10 , 128 , . . . &gt;&gt; } } , { { 142 , 250 , 231 , 47 } , 2081 , { icmp , &lt;&lt; 11 , 0 , 255 , 254 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 93 , 64 , 0 , 1 , 17 , 109 , 30 , 10 , . . . &gt;&gt; } } , { { 142 , 251 , 236 , 131 } , 1322 , { icmp , &lt;&lt; 11 , 0 , 255 , 254 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 94 , 64 , 0 , 1 , 17 , 109 , 29 , . . . &gt;&gt; } } , { { 108 , 170 , 234 , 239 } , 3121 , { icmp , &lt;&lt; 11 , 0 , 255 , 254 , 0 , 17 , 0 , 0 , 69 , 96 , 0 , 28 , 1 , 95 , 64 , 0 , 1 , 17 , 109 , . . . &gt;&gt; } } , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 64 , 233 , 191 , 139 } , 917 , { icmp , &lt;&lt; 3 , 3 , 8 , 13 , 0 , 0 , 0 , 0 , 69 , . . . &gt;&gt; } } ]","ref":"tracert.html#host/2"},{"type":"function","title":"tracert.host/3","doc":"Perform a traceroute to a destination. ICMP and UDP probes are supported. ICMP probes are the default. max_hops is the maximum TTL (default: 30) Set the time in milliseconds to wait for a response using the timeout option (default: 1000 ms). WARNING: if the response arrives after the timeout, tracert will insert spurious entries into the path. tracert will not spawn the setuid helper if the {setuid, false} option is used. In this case, beam must either be running as root or have the cap_net_raw privileges under Linux. The {sport, Port} option sets the initial source port for UDP probes. The port will be incremented by 1 for each subsequent probe (default: random high port). For ICMP probes, the ICMP ID field will be set to this value. The return value is an ordered list of tuples: * Address: the source address responding to the probe * MicroSeconds: time elapsed between the probe and receiving the response * Protocol: icmp or udp * Protocol data: a binary representing the received packet contents Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; } 2 &gt; Path = tracert : host ( Socket , &quot;8.8.8.8&quot; , [ ] ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , { icmp , &lt;&lt; 0 , 0 , 231 , 24 , 158 , 80 , 0 , 0 , 32 , 33 , 34 , 35 , 36 , . . . &gt;&gt; } } ] 3 &gt; tracert : close ( Socket ) . ok 4 &gt; tracert : path ( Path ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , echoreply } ]","ref":"tracert.html#host/3"},{"type":"function","title":"tracert.open/0","doc":"Open an ICMP socket for traceroute Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; }","ref":"tracert.html#open/0"},{"type":"function","title":"tracert.open/1","doc":"Open an ICMP socket for traceroute. Examples 1 &gt; { ok , Socket } = tracert : open ( [ inet6 , { protocol , udp } ] ) . { ok , &lt; 0.289 . 0 &gt; }","ref":"tracert.html#open/1"},{"type":"function","title":"tracert.path/1","doc":"Convert trace response to atoms. Convert the list of binaries returned by host/1,2,3 to atoms representing the ICMP response codes and UDP errors. Examples 1 &gt; { ok , Socket } = tracert : open ( ) . { ok , &lt; 0.164 . 0 &gt; } 2 &gt; Path = tracert : host ( Socket , &quot;8.8.8.8&quot; , [ ] ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , { icmp , &lt;&lt; 0 , 0 , 231 , 24 , 158 , 80 , 0 , 0 , 32 , 33 , 34 , 35 , 36 , . . . &gt;&gt; } } ] 3 &gt; tracert : close ( Socket ) . ok 4 &gt; tracert : path ( Path ) . [ timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , timeout , { { 8 , 8 , 8 , 8 } , 750 , echoreply } ]","ref":"tracert.html#path/1"},{"type":"function","title":"tracert.probe/5","doc":"Send a traceroute probe packet.","ref":"tracert.html#probe/5"},{"type":"type","title":"tracert.option/0","doc":null,"ref":"tracert.html#t:option/0"},{"type":"type","title":"tracert.socket/0","doc":null,"ref":"tracert.html#t:socket/0"},{"type":"extras","title":"Overview","doc":"[![Package Version](https://img.shields.io/hexpm/v/gen_icmp)](https://hex.pm/packages/gen_icmp)\n[![Hex Docs](https://img.shields.io/badge/hex-docs)](https://hexdocs.pm/gen_icmp/)\n\ngen\\_icmp aspires to be a simple interface for using ICMP and ICMPv6\nsockets in Erlang, just like gen\\_tcp and gen\\_udp do for their protocol\ntypes; incidentally messing up Google searches for whomever someday\nwrites a proper gen\\_icmp module.\n\ngen\\_icmp uses procket to get a raw socket and abuses gen\\_udp for the\nsocket handling. gen\\_icmp should work on Linux and BSDs.\n\nFor a simple example of sending a ping, also see:\n\nhttps://github.com/msantos/procket/blob/master/src/icmp.erl","ref":"readme.html"},{"type":"extras","title":"EXPORTS - Overview","doc":"```\nopen() -> {ok, Socket}\nopen(SocketOptions) -> {ok, Socket}\nopen(RawOptions, SocketOptions) -> {ok, Socket}\n\n    Types   Socket = pid()\n            RawOptions = [ RawOption ]\n            RawOption = options()\n            SocketOptions = SocketOpt\n            SocketOpt = [ {active, true} | {active, once} |\n                {active, false} | inet | inet6 ]\n\n    By default, the ICMP socket is opened in {active,false} mode. No\n    packets will be received by the socket. setopts/2 can be used\n    to place the socket in {active,true} mode.\n\n    See the procket README for the raw socket options and for\n    instructions on setting up the setuid helper.\n\n    gen_icmp first attempts to natively open the socket and falls\n    back to forking the setuid helper program if beam does not have\n    the appropriate privileges.  Privileges to open a raw socket can\n    be given by, for example, running as root or, on Linux, granting\n    the CAP_NET_RAW capability to beam:\n\n        setcap cap_net_raw=ep /usr/local/lib/erlang/erts-5.8.3/bin/beam.smp\n\n    Only the owning process will receive ICMP packets (see\n    controlling_process/2 to change the owner). The process owning the\n    raw socket will receive all ICMP packets sent to the host.\n\n    Messages sent to the controlling process are:\n\n    {icmp, Socket, Address, TTL, Packet}\n\n    Where:\n\n        * Socket is the pid of the gen_icmp process\n\n        * Address is a tuple representing the IPv4 or IPv6 source address\n\n        * TTL is the IP TTL\n            * IPv4: TTL taken from the IP header\n            * IPv6: the socket's hop limit returned from\n              getsockopt(IPV6_UNICAST_HOPS) (this is not the packet's\n              TTL, it is the socket's max TTL)\n\n        * Packet is the complete ICMP packet including the ICMP headers\n\nclose(Socket) -> ok | {error, Reason}\n\n    Types   Socket = pid()\n            Reason = posix()\n\n    Close the ICMP socket.\n\nsend(Socket, Address, Packet) -> ok | {error, Reason}\n\n    Types   Socket = pid()\n            Address = tuple()\n            Packet = binary()\n            Reason = not_owner | posix()\n\n    Like the gen_udp and gen_tcp modules, any process can send ICMP\n    packets but only the owner will receive the responses.\n\nrecv(Socket, Length) -> {ok, {Address, Packet}} | {error, Reason}\nrecv(Socket, Length, Timeout) -> {ok, {Address, Packet}} | {error, Reason}\n\n    Types   Socket = socket()\n            Length = int()\n            Address = ip_address()\n            Packet = [char()] | binary()\n            Timeout = int() | infinity\n            Reason = not_owner | posix()\n\n    This function receives a packet from a socket in passive mode.\n\n    The optional Timeout parameter specifies a timeout in\n    milliseconds. The default value is infinity.\n\ncontrolling_process(Socket, Pid) -> ok\n\n    Types   Socket = pid()\n            Pid = pid()\n\n    Change the process owning the socket. Allows another process to\n    receive the ICMP responses.\n\nsetopts(Socket, Options) ->\n\n    Types   Socket = pid()\n            Options = list()\n\n    For options, see the inet man page. Simply calls inet:setopts/2\n    on the gen_udp socket.\n\n    setopts/2 can be used to toggle the socket between passive and\n    active mode:\n\n        {ok, Socket} = gen_icmp:open(), % socket is {active,false}\n        ok = gen_icmp:setopts(Socket, [{active, true}]),\n        % do stuff with the socket\n        ok = gen_icmp:setopts(Socket, [{active, false}]).\n\nping(Host) -> Responses\nping(Host, Options) -> Responses\nping(Socket, Hosts, Options) -> Responses\n\n    Types   Socket = pid()\n            Host = Address | Hostname | Hosts\n            Address = ReplyAddr = tuple()\n            Hostname = string()\n            Hosts = [ tuple() | string() ]\n            Options = [ Option ]\n            Option = {id, Id} | {sequence, Sequence} | {timeout, Timeout} | {data, Data} |\n                {timestamp, boolean()} | {ttl, TTL} | {filter, Filter} | inet | inet6\n            Id = uint16()\n            Sequence = uint16()\n            Timeout = non_neg_integer() | infinity\n            TTL = uint8()\n            Data = binary()\n            Filter = binary()\n            Responses = [ Response ]\n            Response = {ok, Host, Address, ReplyAddr, Details, Payload}\n                | {error, ICMPError, Host, Address, ReplyAddr, Details, Payload}\n                | {error, Error, Host, Address}\n            Details = {Id, Sequence, TTL, Elapsed}\n            Elapsed = int() | undefined\n            Payload = binary()\n            ICMPError = unreach_host | timxceed_intrans\n            Error = timeout | inet:posix()\n\n    ping/1 is a convenience function to send a single ping\n    packet. The argument to ping/1 can be either a hostname or a\n    list of hostnames.\n\n    To prevent the process mailbox from being flooded with ICMP\n    messages, ping/3 will put the socket into {active,false} mode\n    after completing.\n\n    The ping/3 function blocks until either an ICMP ECHO REPLY is\n    received from all hosts or Timeout is reached.\n\n    Id and sequence are used to differentiate ping responses. Usually,\n    the sequence is incremented for each ping in one run.\n\n    A list of responses is returned. If the ping was successful,\n    the elapsed time in milliseconds is included (calculated by\n    subtracting the current time from the time we sent in the ICMP\n    ECHO packet and returned to us in the ICMP ECHOREPLY payload)\n    where:\n\n        Host: the provided hostname\n\n        Address: the resolved IPv4 or IPv6 network address represented\n        as a 4 or 8-tuple used in the ICMP echo request\n\n        ReplyAddr: the IPv4 or IPv6 network address originating the\n        ICMP echo reply\n\n    The timeout is set for all ICMP packets and is set after all\n    packets have been sent out.\n\n    ping/1 and ping/2 open and close an ICMP socket for the user. For\n    best performance, ping/3 should be used instead, with the socket\n    being maintained between runs.\n\n    By default only one address per hostname is pinged. To\n    enable pinging all addresses per hostname pass {multi, true}\n    to options.\n\n    A ping payload contains an 8 byte timestamp in microseconds. When\n    creating a custom payload, the first 8 bytes of the ICMP echo\n    reply payload will be used for calculating the elapsed time. To\n    disable this behaviour, use the option {timestamp,false} (the\n    elapsed time in the return value will be set to 0).\n\n    The timeout defaults to 5 seconds.\n\n    ICMPv6 sockets can restrict which ICMPv6 types are received by the\n    socket using the filter option.  The filter argument is a binary\n    generated using the icmp6_filter functions described below.\n\n    The default filter allows: ICMP6_ECHO_REPLY, ICMP6_DST_UNREACH,\n    ICMP6_PACKET_TOO_BIG, ICMP6_TIME_EXCEEDED and ICMP6_PARAM_PROB.\n    Note: ping/3 does not restore the original filter on the socket.\n\necho(Id, Sequence) -> Packet\n\n    Types   Id = uint16()\n            Sequence = uint16()\n            Packet = binary()\n\n    Creates an ICMP echo packet with an 8 byte timestamp and a\n    payload consisting of ASCII 32 to 79.\n\necho(Id, Sequence, Payload) -> Packet\n\n    Types   Id = uint16()\n            Sequence = uint16()\n            Payload = binary()\n            Packet = binary()\n\n    Creates an ICMP echo packet with the results of erlang:now() used\n    as the timestamp and a user specified payload (which should pad the\n    packet to 64 bytes).\n\n\npacket(Header, Payload) -> Packet\n\n    Types   Header = [ #icmp{} | Options ]\n            Options = [ Opts ]\n            Opts = [{type, Type} | {code, Code} | {id, Id} | {sequence, Sequence} |\n                        {gateway, Gateway} | {mtu, MTU} | {pointer, Pointer} |\n                        {ts_orig, TS_orig} | {ts_recv, TS_recv} | {ts_tx, TS_tx} ]\n            Type = uint8() | ICMP_type\n            Code = uint8() | ICMP_code\n            ICMP_type = echoreply | dest_unreach | source_quench | redirect | echo |\n                time_exceeded | parameterprob | timestamp | timestampreply | info_request |\n                info_reply | address | addressreply\n            ICMP_code = unreach_net | unreach_host | unreach_protocol | unreach_port |\n                unreach_needfrag | unreach_srcfail | redirect_net | redirect_host |\n                redirect_tosnet | redirect_toshost | timxceed_intrans | timxceed_reass\n            Id = uint16()\n            Sequence = uint16()\n            Payload = binary()\n            Packet = binary()\n\n    Convenience function for creating arbitrary ICMP packets. This\n    function will calculate the ICMP checksum and insert it into the\n    packet.\n\nfilter(Socket) -> {ok, Filter} | unsupported\nfilter(Socket, Filter) -> ok | unsupported\n\n    Types   Socket = pid()\n            Filter = binary()\n\n    Sets or retrieves an ICMPv6 filter on a socket. For ICMPv4\n    sockets, the atom 'unsupported' is returned.\n\n    Filters can be generated by using the icmp6_filter functions.\n\nicmp6_filter_setblockall() -> binary()\nicmp6_filter_setpassall() -> binary()\nicmp6_filter_setpass(Type, Filter) -> binary()\nicmp6_filter_setblock(Type, Filter) -> binary()\nicmp6_filter_willpass(Type, Filter) -> true | false\nicmp6_filter_willblock(Type, Filter) -> true | false\n\n    Types   Type = icmp_type()\n            Filter = binary()\n\n    Generate a ICMPv6 filter that can be set on a socket using\n    filter/2.\n\n    For example, to generate a filter that allowed only\n    ICMP6_ECHO_REPLY messages:\n\n        {ok, Socket} = gen_icmp:open([inet6]),\n        Filter = gen_icmp:icmp6_filter_setpass(echo_reply,\n                    gen_icmp:icmp6_filter_setblockall()),\n        ok = gen_icmp:filter(Socket, Filter).\n```\n\n#","ref":"readme.html#exports"},{"type":"extras","title":"Traceroute - Overview","doc":"tracert is an Erlang traceroute implementation built using gen_icmp.\n\n```\nhost(Host) -> Path\nhost(Host, Options) -> Path\nhost(Socket, Host, Options) -> Path\n\n    Types   Socket = pid()\n            Host = Address | Hostname\n            Address = tuple()\n            Hostname = string()\n            Options = [ Option ]\n            Option = {protocol, Protocol}\n                | {max_hops, uint()}\n                | {timeout, uint()}\n                | {setuid, bool()}\n                | {saddr, Address}\n                | {sport, uint16()}\n            Protocol = icmp | udp\n            Path = [ {Address, MicroSeconds, {Protocol, binary()}\n                | timeout ]\n\n    Perform a traceroute to a destination. ICMP and UDP probes are\n    supported. ICMP probes are the default.\n\n    max_hops is the maximum TTL (default: 30)\n\n    Set the time in milliseconds to wait for a response using the\n    timeout option (default: 1000 ms).  WARNING: if the response\n    arrives after the timeout, tracert will insert spurious entries\n    into the path.\n\n    tracert will not spawn the setuid helper if the {setuid, false}\n    option is used. In this case, beam must either be running as\n    root or have the cap_net_raw privileges under Linux.\n\n    The {sport, Port} option sets the initial source port for UDP\n    probes. The port will be incremented by 1 for each subsequent\n    probe (default: random high port).  For ICMP probes, the ICMP\n    ID field will be set to this value.\n\n    The return value is an ordered list of tuples:\n\n        Address: the source address responding to the probe\n\n        MicroSeconds: time elapsed between the probe and receiving\n        the response\n\n        Protocol: icmp or udp\n\n        Protocol data: a binary representing the received packet\n        contents\n\npath(Path) -> Reasons\n\n    Types   Path = [ {Address, MicroSeconds, {Protocol, binary()} ]\n            Reasons = [ {Address, MicroSeconds, Reason} ]\n            Reason = ICMP | UDP | timeout\n            ICMP = timxceed_intrans | echo_reply | ...\n            UDP = unreach_port | ...\n\n    Convert the list of binaries returned by host/1,2,3 to atoms\n    representing the ICMP response codes and UDP errors.\n```","ref":"readme.html#traceroute"},{"type":"extras","title":"COMPILING - Overview","doc":"```\nrebar3 do clean, compile, ct\n```\n\nAlso see the README for procket for additional setup (the procket\nexecutable needs superuser privileges).","ref":"readme.html#compiling"},{"type":"extras","title":"EXAMPLE - Overview","doc":"#","ref":"readme.html#example"},{"type":"extras","title":"Simple ping interface - Overview","doc":"```\n1> gen_icmp:ping(\"www.google.com\").\n[{ok,\"www.google.com\",\n     {173,194,64,99},\n     {173,194,64,99},\n     18411,0,50,\n      >}]\n\n2> gen_icmp:ping([\"www.google.com\", {192,168,213,4}, \"193.180.168.20\", {192,0,32,10}]).\n[{error,timeout,\"193.180.168.20\",{193,180,168,20}},\n {error,unreach_host,\n        {192,168,213,4},\n        {192,168,213,4},\n        {192,168,213,54},\n        {18411,2,undefined},\n         >},\n {ok,{192,0,32,10},\n     {192,0,32,10},\n     {192,0,32,10},\n     {18411,1,103},\n      >},\n {ok,\"www.google.com\",\n     {173,194,77,99},\n     {173,194,77,99},\n     {18411,0,50},\n      >}]\n```\n\n#","ref":"readme.html#simple-ping-interface"},{"type":"extras","title":"IPv6 - Overview","doc":"```\n1> gen_icmp:ping(\"google.com\", [inet6]).\n[{ok,\"google.com\",\n     {9735,63664,16395,2054,0,0,0,4098},\n     {9735,63664,16395,2054,0,0,0,4098},\n     {18411,0,64,62},\n      >}]\n\n2> tracert:host(\"google.com\", [inet6]).\n```\n\n#","ref":"readme.html#ipv6"},{"type":"extras","title":"Re-using the ICMP ping socket - Overview","doc":"Keeping the ICMP socket around between runs is more efficient:\n\n```\n{ok, Socket} = gen_icmp:open(),\nP1 = gen_icmp:ping(Socket, [{10,1,1,1}, \"www.google.com\"], []),\nP2 = gen_icmp:ping(Socket, [{10,2,2,2}, \"www.yahoo.com\"], []),\ngen_icmp:close(Socket).\n```\n\n#","ref":"readme.html#re-using-the-icmp-ping-socket"},{"type":"extras","title":"Working with ICMP sockets - Overview","doc":"```\n{ok, Socket} = gen_icmp:open().\n\n% By default, the ICMP socket is in passive mode\nok = gen_icmp:setopts(Socket, [{active, true}]),\n\n% ICMP host unreachable, empty payload (should contain an IPv4 header\n% and the first 8 bytes of the packet data)\nPacket = gen_icmp:packet([{type, 3}, {code, 0}],  >).\n\ngen_icmp:send(Socket, {127,0,0,1}, Packet),\n\n% Put the socket back into passive mode\nok = gen_icmp:setopts(Socket, [{active, false}]).\n```\n\n#","ref":"readme.html#working-with-icmp-sockets"},{"type":"extras","title":"Setting Up an ICMP Ping Tunnel - Overview","doc":"ptun is an example of using gen\\_icmp to tunnel TCP over ICMP.\n\nTo compile ptun:\n\n```\nmake eg\n```\n\nHost1 (1.1.1.1) listens for TCP on port 8787 and forwards the data\nover ICMP:\n\n```\nerl -noshell -pa ebin deps/*/ebin -eval 'ptun:server({2,2,2,2},8787)' -s erlang halt\n```\n\nHost2 (2.2.2.2) receives ICMP echo requests and opens a TCP connection\nto 127.0.0.1:22:\n\n```\nerl -noshell -pa ebin deps/*/ebin -eval 'ptun:client({1,1,1,1},22)' -s erlang halt\n```\n\nTo use the proxy on host1:\n\n```\nssh -p 8787 127.0.0.1\n```\n\n#","ref":"readme.html#setting-up-an-icmp-ping-tunnel"},{"type":"extras","title":"Traceroute - Overview","doc":"* ICMP traceroute\n\n  ```\n    1> Path = tracert:host({8,8,8,8}).\n    [{{216,239,46,191},\n     36149,\n     {icmp, >}},\n     {{216,239,47,189},\n     51459,\n     {icmp, >}},\n     {{8,8,8,8},\n     34946,\n     {icmp, >}}]\n\n    2> tracert:path(Path).\n    [{{216,239,46,191},62815,timxceed_intrans},\n     {{216,239,47,189},44244,timxceed_intrans},\n     {{8,8,8,8},34825,echoreply}]\n  ```\n\n* UDP traceroute\n\n  ```\n    1> Path = tracert:host({8,8,8,8}, [{protocol, udp}]).\n  ```\n\n* IPv6 traceroute\n\n  ```\n    1> Path = tracert:host(\"google.com\", [inet6]).\n  ```\n\n#","ref":"readme.html#traceroute"},{"type":"extras","title":"TODO - Overview","doc":"* tests: do not depend on list order\n\n* handle rfc 4884 (Extended ICMP to Support Multi-Part Messages)\n\n* handle ICMP router renumbering messages\n\n* IPv6: handle socket ancillary data (RFC 3542)\n  * retrieve the packet TTL rather than using the IPV6\\_UNICAST\\_HOPS","ref":"readme.html#todo"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2010-2024 Michael Santos  . All\nrights reserved.\n\nRedistribution and use in source and binary forms, with or without\nmodification, are permitted provided that the following conditions\nare met:\n\n1. Redistributions of source code must retain the above copyright notice,\nthis list of conditions and the following disclaimer.\n\n2. Redistributions in binary form must reproduce the above copyright\nnotice, this list of conditions and the following disclaimer in the\ndocumentation and/or other materials provided with the distribution.\n\n3. Neither the name of the copyright holder nor the names of its\ncontributors may be used to endorse or promote products derived from\nthis software without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n\"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\nLIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\nA PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\nHOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\nSPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED\nTO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR\nPROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\nLIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\nNEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\nSOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"}],"content_type":"text/plain"}